package Gelateria;

public class GelateriaMultilock extends Gelateria 
{
	
	public void getCono(int Gusto1, int Gusto2) throws InterruptedException
	{
		Vaschetta v1;
		Vaschetta v2;
		
		if (Gusto1 > Gusto2)
		{
			int tmp;
			tmp = Gusto1;
			Gusto1 = Gusto2;
			Gusto2 = tmp;
		}
		v1 = vaschette.get(Gusto1);
		v2 = vaschette.get(Gusto2);
		
				v1.l.lock();
		v2.l.lock();
		
		while ( ! (v1.quantita >= dimPalla && v2.quantita >= dimPalla)  )
		{
			if(v1.quantita < dimPalla)
			{
				v1.c.await();
			}
			else v2.c.await();
				
		}
		v1.quantita -= dimPalla;
		v2.quantita -= dimPalla;

		v1.l.unlock();
		v2.l.unlock();
	}

	public void getOneBall(Vaschetta v) throws InterruptedException
	{
		
		v.l.lock();
		while ( v.quantita < dimPalla  )
		{
				v.c.await();
				
		}
		v.quantita -= dimPalla;
		v.l.unlock();

	}
	
	public void getConoDueStep(int Gusto1, int Gusto2) throws InterruptedException
	{
		
		getOneBall(vaschette.get(Gusto1));
		getOneBall(vaschette.get(Gusto2));
		
	}

	
	public int getConoCumeDede(int Gusto1, int Gusto2)
	{
		
	    vaschette.get(Gusto1).l.lock();
		int r1 = prendiGusto(Gusto1);
		vaschette.get(Gusto1).l.unlock();
		
		vaschette.get(Gusto2).l.lock();
		int r2 = prendiGusto(Gusto2);
		vaschette.get(Gusto2).l.unlock();
		
		if( r1 == 1 &&  r2 == 1 )
			return 1;
		else if (r1 == -1 || r2 == -1)
			return -1;
		else return 0;
	}
	
	public void riempi(Vaschetta v)
	{
		v.l.lock();
		v.quantita = 1000;
		v.c.signalAll();
		v.l.unlock();
	}

}
